if ~exist('save_name'),
    save_name = 'Calib_Results';
end;

fprintf(1,'Generating the JSON file %s.json containing the intrinsic parameters...\n',save_name)


fid = fopen([ save_name '.json'],'wt');

fprintf(fid,'{\n');

time = clock;
fprintf(fid,' \"calibration_date\": \"%02d-%02d-%4d %02d:%02d\",\n\n', time(3), time(2), time(1), time(4), time(5));

fprintf(fid,' \"camera_matrix\": [\n');
fprintf(fid,'     [%5.15f, %5.15f, %5.15f]\n', fc(1), fc(1)*alpha_c, cc(1));
fprintf(fid,'     [0., %5.15f, %5.15f]\n', fc(2),  cc(2));
fprintf(fid,'     [0., 0., 1. ]\n');
fprintf(fid,'   ],\n');

fprintf(fid,' \"distortion_coefficients\": [ %5.15f, %5.15f, %5.15f, %5.15f, %5.15f ],\n', kc);

fprintf(fid,' \"nx\": %d,\n', nx);
fprintf(fid,' \"ny\": %d,\n', ny);

fprintf(fid,' \"fc\": [ %5.15f, %5.15f ],\n', fc);
fprintf(fid,' \"cc\": [ %5.15f, %5.15f ],\n', cc);
fprintf(fid,' \"alpha_c\": %5.15f,\n\n', alpha_c);
fprintf(fid,' \"kc\": [ %5.15f, %5.15f, %5.15f, %5.15f, %5.15f ],\n', kc);

fprintf(fid,' \"fc_error\": [ %5.15f, %5.15f ],\n', fc_error);
fprintf(fid,' \"cc_error\": [ %5.15f, %5.15f ],\n', cc_error);
fprintf(fid,' \"alpha_c_error\": %5.15f,\n\n', alpha_c_error);
fprintf(fid,' \"kc_error\": [ %5.15f, %5.15f, %5.15f, %5.15f, %5.15f ],\n', kc_error);

fprintf(fid,'}\n');

fclose(fid);