if ~exist('save_name'),
    save_name = 'Calib_Results';
end;

fprintf(1,'Generating the YAML file %s.yaml containing the intrinsic parameters...\n',save_name)


fid = fopen([ save_name '.yaml'],'wt');

fprintf(fid,'%%YAML:1.0\n\n');
fprintf(fid,'#-- Intrinsic Camera Parameters\n\n');

time = clock;
fprintf(fid,'calibration_date: \"%02d-%02d-%4d %02d:%02d\"\n\n', time(3), time(2), time(1), time(4), time(5));

fprintf(fid,'camera_matrix:  !!opencv-matrix\n');
fprintf(fid,' rows: 3\n');
fprintf(fid,' cols: 3\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f, %5.15f, %5.15f,', fc(1), fc(1)*alpha_c, cc(1));
fprintf(fid,' 0., %5.15f, %5.15f,', fc(2),  cc(2));
fprintf(fid,' 0., 0., 1. ]\n\n');

fprintf(fid,'distortion_coefficients:  !!opencv-matrix\n');
fprintf(fid,' rows: 4\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f, %5.15f, %5.15f, %5.15f ]\n\n', kc);

fprintf(fid,'#-- Other information:\n\n');

fprintf(fid,'#-- image_size:\n');
fprintf(fid,'nx: %d\n',nx);
fprintf(fid,'ny: %d\n',ny);
fprintf(fid,'\n');

fprintf(fid,'#-- Focal length:\n');
fprintf(fid,'fc:  !!opencv-matrix\n');
fprintf(fid,' rows: 2\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f , %5.15f ]\n\n',fc);

fprintf(fid,'#-- Principal point:\n');
fprintf(fid,'cc:  !!opencv-matrix\n');
fprintf(fid,' rows: 2\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f , %5.15f ]\n\n',cc);

fprintf(fid,'#-- Distortion coefficients:\n');
fprintf(fid,'kc:  !!opencv-matrix\n');
fprintf(fid,' rows: 4\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f, %5.15f, %5.15f, %5.15f ]\n\n', kc);

fprintf(fid,'#-- Skew coefficient:\n');
fprintf(fid,'alpha_c: %5.15f\n\n',alpha_c);

fprintf(fid,'#-- Focal length uncertainty:\n');
fprintf(fid,'fc_error:  !!opencv-matrix\n');
fprintf(fid,' rows: 2\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f , %5.15f ]\n\n',fc_error);

fprintf(fid,'#-- Principal point uncertainty:\n');
fprintf(fid,'cc_error:  !!opencv-matrix\n');
fprintf(fid,' rows: 2\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f , %5.15f ]\n\n',cc_error);

fprintf(fid,'#-- Distortion coefficients uncertainty:\n');
fprintf(fid,'kc_error:  !!opencv-matrix\n');
fprintf(fid,' rows: 4\n');
fprintf(fid,' cols: 1\n');
fprintf(fid,' dt: d\n');
fprintf(fid,' data: [ %5.15f , %5.15f , %5.15f , %5.15f  ]\n\n', kc_error);

fprintf(fid,'#-- Skew coefficient uncertainty:\n');
fprintf(fid,'alpha_c_error: %5.15f;\n\n',alpha_c_error);
 
fclose(fid);